/* Copyright (C) 1995, 1996, 1997, 1998, 2003, 2004, 2005
   Free Software Foundation, Inc.

   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#include <sysdep-cancel.h>
#include <socketcall.h>

#define P(a, b) P2(a, b)
#define P2(a, b) a##b

	.text
/* The socket-oriented system calls are handled unusally in Linux.
   They are all gated through the single `socketcall' system call number.
   `socketcall' takes two arguments: the first is the subcode, specifying
   which socket function is being called; and the second is a pointer to
   the arguments to the specific function.

   The .S files for the other calls just #define socket and #include this.  */

#ifndef __socket
# ifndef NO_WEAK_ALIAS
#  define __socket P(__,socket)
# else
#  define __socket socket
# endif
#endif

#define PUSHARGS_1	subi sp, sp, 4 ;  \
			stw r4, 0(sp)
#define PUSHARGS_2	subi sp, sp, 8 ;  \
			stw r5, 4(sp) ;   \
			stw r4, 0(sp)
#define PUSHARGS_3	subi sp, sp, 12	; \
			stw r6, 8(sp) ;   \
			stw r5, 4(sp) ;   \
			stw r4, 0(sp)
#define PUSHARGS_4	subi sp, sp, 16	; \
			stw r7, 12(sp) ;  \
			stw r6, 8(sp) ;   \
			stw r5, 4(sp) ;   \
			stw r4, 0(sp)
#define PUSHARGS_5	PUSHARGS_4	/* Caller has already pushed arg 5 */
#define PUSHARGS_6	PUSHARGS_4

#define POPARGS_1	addi sp, sp, 4
#define POPARGS_2	addi sp, sp, 8
#define POPARGS_3	addi sp, sp, 12
#define POPARGS_4	addi sp, sp, 16
#define POPARGS_5	addi sp, sp, 16
#define POPARGS_6	addi sp, sp, 16

#ifndef NARGS
#define NARGS 3			/* If we were called with no wrapper, this is really socket() */
#endif

.globl __socket
ENTRY (__socket)
	/* Push args onto the stack.  */
	P(PUSHARGS_,NARGS)

#if defined NEED_CANCELLATION && defined CENABLE
	SINGLE_THREAD_P(r2)
	bne r2,zero,2f
#endif

        /* Do the system call trap.  */
	movi r4, P(SOCKOP_,socket)
	mov r5, sp
	movi r2, SYS_ify(socketcall)
	trap

	/* Pop args off the stack.  */
	P(POPARGS_,NARGS)

	/* Check for errors.  */
	bne r7,zero,SYSCALL_ERROR_LABEL

	ret
#if defined NEED_CANCELLATION && defined CENABLE

2:	subi sp, sp, 20
	stw ra, 0(sp)
	stw r22, 4(sp)

	nextpc r22
1:	movhi r2, %hiadj(_GLOBAL_OFFSET_TABLE_ - 1b)
	addi r2, r2, %lo(_GLOBAL_OFFSET_TABLE_ - 1b)
	add r22, r22, r2

	CENABLE
	callr r3
	stw r16, 8(sp)

	movi r4, P(SOCKOP_,socket)
	addi r5, sp, 20
	movi r2, SYS_ify(socketcall)
	trap

	stw r2, 12(sp)
	stw r7, 16(sp)
	ldw r4, 8(sp)
	CDISABLE
	callr r3
	ldw r7, 16(sp)
	ldw r2, 12(sp)
	ldw r22, 4(sp)
	ldw ra, 0(sp)
	addi sp, sp, 20

	P(POPARGS_,NARGS)

	bne r7, zero, SYSCALL_ERROR_LABEL
	ret
#endif

PSEUDO_END (__socket)

#ifndef NO_WEAK_ALIAS
weak_alias (__socket, socket)
#endif
